/*
	DEGL.java
	Isaac Triguero Velazquez.
	
	Created by Isaac Triguero Velazquez  23-7-2009
	Copyright (c) 2008 __MyCompanyName__. All rights reserved.

*/
package org.sci2s.eamhco;


import java.util.*;

import java.util.StringTokenizer;
import cec05.benchmark;
import cec05.test_func;




/**
 * @author Isaac Triguero
 * @version 1.0
 */
public class DEGLGenerator{

  /*Own parameters of the algorithm*/
  

 
  private int PopulationSize; 
  private int Dimension;
  private int MaxIter; 
  private double ScalingFactor;
  private double CrossOverRate;
  private double WeightFactor;
  private double WeightFactorAdap[];
  private int neighboors; /// numbers of neighboor to search.
  private String WeightScheme;

  private double PI = 3.14159265358;
  private long semilla;
  
  private int MaxEval;
  private int eval;
  private benchmark test;
  private test_func function;
  private double bias;
  private double maxLimit;
  private double minLimit;
  private boolean noBounds = false;
  
  
  public DEGLGenerator(int poblacion, int dimension, int iteraciones, double F, double CR, double WeightFactor, int neighbors, String Wscheme)
  {
      this.PopulationSize = poblacion;
      this.Dimension = dimension;
      this.MaxIter = iteraciones;
      this.ScalingFactor = F;
      this.CrossOverRate = CR;
      this.WeightFactor = WeightFactor;
      this.neighboors = neighbors;
      this.WeightScheme = Wscheme;
	  test = new benchmark();
	  MaxEval = Dimension*10000;
	  eval = 0;
	  function = test.testFunctionFactory(9, dimension);
      
  }
  




  
  public Prototype mutant(ArrayList<Prototype> population, int actual, int bestFitnessIndex, int bestNeighboor){
	  
	  
	  Prototype mutant = new Prototype();
	  Prototype xbest,nbest, p,q, r1,r2, resta1,resta2, producto1,producto2, suma, Local, Global;
	  
	  //Generate the Local trial Vector.
	  
	  nbest = population.get(bestNeighboor);
	  
	  int prandom, qrandom;
	  int inferior =( actual-this.neighboors)%this.PopulationSize;
	  int superior = (actual+this.neighboors)%this.PopulationSize;
	  if (inferior <0 ) inferior *=-1;
	  if (superior <0) superior*= -1;
	  do{
		  prandom = RandomGenerator.Randint(inferior,superior);
		  qrandom = RandomGenerator.Randint(inferior,superior);
	  }while (prandom != actual && qrandom!= prandom && qrandom!=actual);
	  
	  p = population.get(prandom);
	  q = population.get(qrandom);
	  
	  resta1 = nbest.sub(population.get(actual));
	  resta2 = p.sub(q);
	  
	  producto1 = resta1.mul(this.ScalingFactor);
	  producto2 = resta2.mul(this.ScalingFactor);
	  
	  suma = producto1.add(producto2);
	  
	  Local = population.get(actual).add(suma);

	  //Generate the Global trial Vector.

	  xbest = population.get(bestFitnessIndex);

	  int ran1,ran2;
	  
	  do{
		  ran1 = RandomGenerator.Randint(0, this.PopulationSize);
		  ran2 = RandomGenerator.Randint(0, this.PopulationSize);
	  }while (ran1 != actual && ran2!= ran1 && ran2!= actual);
	  
	  r1 = population.get(ran1);
	  r2 = population.get(ran2);
	  
	  resta1 = r1.sub(r2);
	  resta2 = xbest.sub(population.get(actual));
	  
	  producto1 = resta1.mul(this.ScalingFactor);
	  producto2 = resta2.mul(this.ScalingFactor);
	  
	  suma = producto1.add(producto2);
	  
	  Global = population.get(actual).add(suma);
	  
	  
	  // System.out.println("********Mutante**********");
	  
	  if(this.WeightScheme.equals("Adaptive")){
		  producto1 = Global.mul(this.WeightFactorAdap[actual]);
		  producto2 = Local.mul(1-this.WeightFactorAdap[actual]);	  
		  
	  }else{
		  producto1 = Global.mul(this.WeightFactor);
		  producto2 = Local.mul(1-this.WeightFactor);
	  }
	  mutant = producto1.add(producto2);
	  
	  // mutant.print();
	   
     mutant.applyThresholds(minLimit, maxLimit);

	
	  return mutant;
  }
  
  
  
  
  /* Code to evaluate rastrigin's function */
  double calc_rastrigin (double x[])
  {
      int i;
      double res;
      res = 0.0;
      for (i=0; i<this.Dimension; i++)
      {
          res += (x[i]*x[i] - 10.0*Math.cos(2.0*this.PI*x[i]) + 10.0);
      }
      return (res-(330));
  }
  
  /*
   * HERE YOU CAN CHANGE THE FUNCTION: function f9
   */
  
  double fitness(Prototype p){
	  
	  return function.f(p.getInputs());
	  
  }
  
  /**
   * Execute the DEGenerator method.
   */
  
  
  public void execute()
  {
	  //System.out.print("\nThe algorithm  DEGL is starting...\n Computing...\n");
	  
	  // First, we create the population, with PopulationSize.
	  ArrayList<Prototype> population = new ArrayList<Prototype>();
	  Prototype mutation = new Prototype();
	  Prototype crossover = new Prototype();
	  
	  
	  double fitness[] = new double[PopulationSize];
	  double fitness_bestPopulation[] = new double[PopulationSize];
	  Prototype bestParticle = new Prototype();
	  
	  // First Stage, Initialization.
	  
	  for(int i=0; i< PopulationSize; i++){
		  Prototype cromosoma = new Prototype(this.Dimension,1);
		  
		  for(int j=0; j< this.Dimension; j++){
			  cromosoma.setInput(j, RandomGenerator.Randdouble(minLimit, maxLimit));  //Inicialmente aleatorio.
		  }
		  
		  
		  fitness[i]= fitness(cromosoma);
		  eval++;
		//  System.out.println(fitness[i]);
		  population.add(cromosoma);
	  }
	  
	  if(noBounds){
		  maxLimit = Double.MAX_VALUE;
		  minLimit = Double.MIN_VALUE;
	  }
	  
	  
 	  //Find the best initial solution.

	 	  
	  //We select the best initial  particle
	 double bestFitness=fitness[0];
	 int bestFitnessIndex=0;
	
	 for(int i=1; i< PopulationSize;i++){
		  if(fitness[i]<bestFitness){
			  bestFitness = fitness[i];
			  bestFitnessIndex=i;
		  }
		  
	  }
	   
	   // if self adaptative..
	   // Initialy
	   if(this.WeightScheme.equals("Adaptive")){
		   WeightFactorAdap = new double[this.PopulationSize];
		   
		   for(int i=0; i<PopulationSize; i++){
			   WeightFactorAdap[i] = RandomGenerator.Randdouble(0,1);
		   }
	   }
	  

	   
	   boolean exit = false;
	   for(int iter=0; eval < MaxEval && (Math.abs(bestFitness - bias))> Math.pow(10, -8) && !exit; iter++){ // Main loop
		   
			  

				   
			  for(int i=0; i<PopulationSize; i++){
				  
				  
				   //Second:  Mutation Operation.
				   // I want to generate a PrototypeSet Mutation for each item of the population.
				   
				   mutation = new Prototype();
			   
				   // Pasamos la poblaci�n, y la mejor actual, adem�s del mejor del vecindario,
				   int bestNeighboor=0;
				   double bestFitnessNeighboor = Double.MAX_VALUE;
				   
				   //Ring Topology.: Cogemos los neighboors de cada lado.
				   for(int j=i-this.neighboors; j<= i+this.neighboors; j++){
					   //int pos = (i+j)% this.PopulationSize;
					   int pos = (j + this.PopulationSize)% this.PopulationSize;
					   //if (pos <0) pos *=-1;
					   
					   if(fitness[pos]< bestFitnessNeighboor){
						   bestFitnessNeighboor = fitness[pos];
						   bestNeighboor = pos;
					   }
				   }
				   
				   mutation = mutant(population, i,bestFitnessIndex, bestNeighboor);

				   // Third: Binomial Crossver Operation.
				   // Now, we decide if the mutation will be the trial vector.

				   crossover = new Prototype(population.get(i));
				   
				   int j_rand = RandomGenerator.Randint(0, Dimension);
				   for(int j=0; j< (population.get(i)).numberOfInputs(); j++){ // For each part of the solution
					   
					  
						   double randNumber = RandomGenerator.Randdouble(0, 1);
						   
						   if(randNumber< this.CrossOverRate || j == j_rand){
							   crossover.setInput(j, mutation.getInput(j)); 
						   }
				   }
				   
				   
				   // Fourth: Selection Operation.
				   // Decide if the trial vector is better than initial population.
				   //Crossover has the trialVector, we check its fitness.
		
					  double trialVector = fitness(crossover);
					  eval++;
					   if(eval > MaxEval)
						   exit = true;
						

					  if(trialVector < fitness[i]){
						//  System.out.println("Selecting");
						  population.set(i, crossover);
						  fitness[i] = trialVector;
					  }
					   
					  
					  if(fitness[i]<bestFitness){
						  bestFitness = fitness[i];
						  bestFitnessIndex=i;
						  
						 // System.out.println("Iter="+ iter +" Acc= "+ bestFitness); //Useful to show the convergence process.
					  }
					  
				  
				  
			   }
			  
			  if(this.WeightScheme.equals("Linear")){
				  //this.WeightFactor = iter/this.MaxIter *1.;
				  this.WeightFactor = eval/MaxEval *1.;
			  }else if(this.WeightScheme.equals("Exponential")){
				  //this.WeightFactor = Math.exp(iter/this.MaxIter*1.0 * Math.log1p(2))-1;
				  this.WeightFactor = Math.exp(eval/MaxEval*1.0 * Math.log1p(2))-1;
			  }else if(this.WeightScheme.equals("Random")){
				  this.WeightFactor = RandomGenerator.Randdouble(0, 1);
			  }else if(this.WeightScheme.equals("Adaptive")){
				  
				  for(int i=0; i<this.PopulationSize; i++){
					  double prod = this.ScalingFactor*(this.WeightFactorAdap[bestFitnessIndex]-this.WeightFactorAdap[i]); 
					  
					  int ran1,ran2;
					  
					  do{
						  ran1 = RandomGenerator.Randint(0, this.PopulationSize);
						  ran2 = RandomGenerator.Randint(0, this.PopulationSize);
					  }while (ran1 != i && ran2!= ran1 && ran2!= i);
					  
					  double prod2 = this.ScalingFactor*(this.WeightFactorAdap[ran1]-this.WeightFactorAdap[ran2]); 
					  this.WeightFactorAdap[i] += prod + prod2;
					  
					  if(this.WeightFactorAdap[i] > 0.95) this.WeightFactorAdap[i] =0.95;
					  else if(this.WeightFactorAdap[i] < 0.05) this.WeightFactorAdap[i] =0.05;
				  }
			  }
			  
			//  System.out.println("Best Fitness Generaci�n "+iter+" = " + bestFitness);
			 // System.out.println("Acc= "+ bestFitness);

	   } // End main LOOP
	     
		  
	   //System.out.println("Best -> "+ fitness[bestFitnessIndex]); 
	   System.out.println(semilla + "," + function.name() + "," + function.bias() + ","+
				fitness[bestFitnessIndex] + "," + Math.abs(fitness[bestFitnessIndex]-bias) + "," + eval); 
  }
  
  public void leerConfiguracion (String ficheroScript) {

	    String fichero, linea, token;
	    StringTokenizer lineasFichero, tokens;
	    byte line[];
	    int i, j;

	    fichero = Fichero.leeFichero (ficheroScript);
	    lineasFichero = new StringTokenizer (fichero,"\n\r");


	    /*Getting the seed*/
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    semilla = Long.parseLong(tokens.nextToken().substring(1));
		RandomGenerator.setSeed(semilla);
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.PopulationSize = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Dimension = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.MaxIter = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.ScalingFactor = Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.CrossOverRate = Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	   this.WeightFactor = Double.parseDouble(tokens.nextToken().substring(1));
	    
	   linea = lineasFichero.nextToken();
	   tokens = new StringTokenizer (linea, "=");
	   tokens.nextToken();
	   this.neighboors = Integer.parseInt(tokens.nextToken().substring(1));
	   
	   
	   linea = lineasFichero.nextToken();
	   tokens = new StringTokenizer (linea, "=");
	   tokens.nextToken();
	   this.WeightScheme = tokens.nextToken().substring(1);
		
		linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
		int fun =Integer.parseInt(tokens.nextToken().substring(1));
	    this.function = test.testFunctionFactory(fun, Dimension);
		bias = function.bias();
		MaxEval = Dimension*10000;
		eval = 0;
		maxLimit = test.get_max_value(fun);
		minLimit = test.get_min_value(fun);
		if(fun == 7 || fun == 25){
			noBounds = true;
		}
	    

	  }

  
  
  /**
   * @param args Arguments of the main function.
   */
  public static void main(String[] args)
  {
	  
	  RandomGenerator.setSeed(818469644); // established the seed.
	  
	  //Default values
	  int Poblacion=100, dimension=10, iteraciones=100000, neighbors = 2;
	  double F=.9, CR=.5, WeightFactor =0.0;
	  String Wscheme = "Exponential";
	  
	  DEGLGenerator differential = new DEGLGenerator(Poblacion,dimension,iteraciones, F,CR,  WeightFactor, neighbors, Wscheme);
	  
	  if(args.length == 1){
			differential.leerConfiguracion(args[0]);  
		  }
	  
	  differential.execute();
	  
	  
  }

}