
/*
	JADE.java
	Isaac Triguero Velazquez.
	
	Created by Isaac Triguero Velazquez  23-7-2009
	Copyright (c) 2008 __MyCompanyName__. All rights reserved.

*/
package org.sci2s.eamhco;

import java.util.*;
import cec05.benchmark;
import cec05.test_func;


/**

 * @author Isaac Triguero
 * @version 1.0
 */
public class JADEGenerator {

  /*Own parameters of the algorithm*/
	  private long semilla;
 
  private int PopulationSize; 
  private int Dimension;
  private int MaxIter; 
  private double ScalingFactor;
  private double CrossOverRate[];
  private int Strategy;
  private String CrossoverType; // Binomial, Exponential, Arithmetic
  //private boolean Archive; // JAde with or without Archive.
  private double p; // to select the number of pbest
  private double c;

  protected int numberOfbetters; // numero de mejores a tener en cuenta
  
  private int MaxEval;
  private int eval;
  private benchmark test;
  private test_func function;
  private double bias;
  private double maxLimit;
  private double minLimit;
  private boolean noBounds = false;

  private double PI = 3.14159265358;
  
  /**
   * Build a new JADEGenerator Algorithm
   * @param t Original prototype set to be reduced.
   * @param perc Reduction percentage of the prototype set.
   */
  
  public JADEGenerator(int poblacion, int dimension, int iteraciones, double p, double c)
  {
      this.PopulationSize = poblacion;
      this.Dimension = dimension;
      this.MaxIter = iteraciones;
      this.p = p;
      this.c = c;
	  test = new benchmark();
	  MaxEval = Dimension*10000;
	  eval = 0;
	  function = test.testFunctionFactory(9, dimension);

      this.numberOfbetters= (int) (this.p*PopulationSize);
      if( numberOfbetters <1) numberOfbetters  = 1;
  }



  
  public int[] mejoresParticulas(ArrayList<Prototype> population,double fitness[]){
	int number = this.numberOfbetters;
	  int index[] = new int[number];
	  int ind= 0;
	  double mejor = Double.MAX_VALUE;
	  double acc;
	  
	  for(int i=0; i< population.size(); i++){
		  acc =fitness[i]; 
		  
		  if(acc < mejor )
		  {
			ind = i;
			mejor = acc;
		  }	  
	  }
	  index[0] = ind;
	  
	  for (int j=1; j<number; j++){
		  mejor = Double.MAX_VALUE;
		  for(int i=0; i< population.size(); i++){
			  acc = fitness[i];
			  
			  //if(acc > mejor && acc < accuracy(population[index[j-1]],trainingDataSet))
			  if(acc < mejor && acc > fitness[index[j-1]])
			  {
				ind = i;
				mejor = acc;
			  }	  
		  }
		  index[j] =  ind;
	  
	  }
	  return index;
  }
  
  public Prototype mutant(ArrayList<Prototype> population, double fitness[], int actual,  ArrayList<Prototype> Archivo,int utilArchivo){
	  
	  
	  Prototype mutant = new Prototype();
	  Prototype r1,r2,xbest, resta, producto, resta2, producto2, result;
	  
		   
	  // r1 different to actual	      
	  int ran;
	   do{
		   ran =  RandomGenerator.Randint(0, population.size());   
	   }while(ran == actual);
	   
	   r1 = population.get(ran);
	   
	  int number;
	  
	  do{ 
		  number = RandomGenerator.Randint(0, population.size()+ utilArchivo);
	  }while (number==ran || number == actual );
	  
	   if(number < population.size()){
		 r2 = population.get(number);  
	   }else
		 r2 = Archivo.get(number-population.size());
	   
	   // Tengo que sacar los 100p % mejores de la poblaci�n actual.
	  // System.out.println("Numero de p-best = "+ num_mejores);
	  
	   
	   int indices[] = new int [this.numberOfbetters];
	   
	   indices = mejoresParticulas(population,fitness);
	   number = RandomGenerator.Randint(0, indices.length);
	   
	   xbest = population.get(indices[number]);

	   /*
	   for(int i=0; i< population.length; i++){
		   System.out.println(accuracy(population[i],trainingDataSet));
	   }
	   for( int i=0; i< num_mejores ; i++){
		   System.out.println(indices[i]);
	   }
	   */
			switch(this.Strategy){
		   	   case 1: 
		   		   resta = xbest.sub(population.get(actual));
		   		   resta2 = r1.sub(r2);
		   		   
		   		   producto = resta.mul(this.ScalingFactor);
		   		   producto2 = resta2.mul(this.ScalingFactor);
		   		   
		   		   result = producto.add(producto2);
		   		   mutant = population.get(actual).add(result);
		   	    break;
			   		   	
		   }   
	   

	  // System.out.println("********Mutante**********");
	 // mutant.print();
	   
     mutant.applyThresholds(minLimit, maxLimit);
	
	  return mutant;
  }
  
  
  /* Code to evaluate rastrigin's function */
  double calc_rastrigin (double x[])
  {
      int i;
      double res;
      res = 0.0;
      for (i=0; i<this.Dimension; i++)
      {
          res += (x[i]*x[i] - 10.0*Math.cos(2.0*this.PI*x[i]) + 10.0);
      }
      return (res-(330));
  }
  
  /*
   * HERE YOU CAN CHANGE THE FUNCTION: function f9
   */
  
  double fitness(Prototype p){
	  
	  return function.f(p.getInputs());
	  
  }
  
  
  /**
   * Generate a reduced prototype set by the JADEGenerator method.
   * @return Reduced set by JADEGenerator's method.
   */
  
  
  public void execute()
  {
	  //System.out.print("\nThe algorithm  JADE is starting...\n Computing...\n");

	  //Algorithm
	  
	  // First, we create the population, with PopulationSize.
	  ArrayList<Prototype> population = new ArrayList<Prototype>();
	  Prototype mutation = new Prototype();
	  Prototype crossover = new Prototype();
	  
	  
	  double fitness[] = new double[PopulationSize];
	  
	  double meanCR = 0.5;
	  double meanF = 0.5;
	  ArrayList<Prototype> Archivo = new ArrayList<Prototype>();
	  int utilArchivo = 0;
	  
	  // we save the different successful F and CR.
	  double SF[] = new double[this.PopulationSize];
	  double SCR[] = new double[this.PopulationSize];
	  
	  this.CrossOverRate= new double[this.PopulationSize];
	  double F[] = new double[this.PopulationSize];
	  

	  //Each particle must have   Particle Size %

	  // First Stage, Initialization.
	  
	  for(int i=0; i< PopulationSize; i++){
		  Prototype cromosoma = new Prototype(this.Dimension,1);
		  
		  for(int j=0; j< this.Dimension; j++){
			  cromosoma.setInput(j, RandomGenerator.Randdouble(minLimit, maxLimit));  //Inicialmente aleatorio.
		  }
		  
		  
		  fitness[i]= fitness(cromosoma);
		  eval++;
		//  System.out.println(fitness[i]);
		  population.add(cromosoma);
		  Archivo.add(cromosoma); // to initialize the archive
	  }
	  
	  if(noBounds){
		  maxLimit = Double.MAX_VALUE;
		  minLimit = Double.MIN_VALUE;
	  }
	  
	  
 	  //Find the best initial solution.

	 	  
	  //We select the best initial  particle
	 double bestFitness=fitness[0];
	 int bestFitnessIndex=0;
	
	 for(int i=1; i< PopulationSize;i++){
		  if(fitness[i]<bestFitness){
			  bestFitness = fitness[i];
			  bestFitnessIndex=i;
		  }
		  
	  }
	 
	this.Strategy = 1;
	
	   boolean exit = false;
	   for(int iter=0; eval < MaxEval && (Math.abs(bestFitness - bias))> Math.pow(10, -8) && !exit; iter++){ // Main loop
		   //System.err.println(bestFitness+" "+iter);
			  int utilF = 0;
			  int utilCR = 0;
			  
			  // If we are going to use exponential, I calculate the index of possible selecting  Mutation.
 
				   
			  for(int i=0; i<PopulationSize; i++){
				  
				  //Generate CRi
				  this.CrossOverRate[i] = RandomGenerator.RandGaussian()*0.1 + meanCR;
				  //Normalize
				  if(this.CrossOverRate[i]>1) this.CrossOverRate[i] =1;
				  else if(this.CrossOverRate[i]<0) this.CrossOverRate[i] =0;
				  
				  //Generate Fi
				  double uniforme;
				  do{
					  uniforme= RandomGenerator.Randdouble(0,1);
					  F[i]  = 0.1*Math.tan(this.PI*uniforme) + meanF;
				  }while (F[i] <=0);
				  
				  if(F[i] >1) F[i] = 1;
				         
			      if( Double.isNaN(F[i]) ){
					  F[i] = RandomGenerator.Randdouble(0.1, 1);
				  }
				  this.ScalingFactor = F[i];
				 // System.out.println("Fi = " + F[i]);
				  //System.out.println("CRi = "+ this.CrossOverRate[i]);
				  // Randomly choose xbestp, as one of the 100p% best Vector
				  
				   //Second:  Mutation Operation.
				   // I want to generate a PrototypeSet Mutation for each item of the population.
				   
				   mutation = new Prototype();
			   
				   // Pasamos la poblaci�n, y la mejor actual, por si se usa /best/
				   mutation = mutant(population,fitness, i, Archivo, utilArchivo);

				   // Third: Crossver Operation.
				   // Now, we decide if the mutation will be the trial vector.

				   crossover= new Prototype(population.get(i));
				   int j_rand = RandomGenerator.Randint(0, Dimension);
				   
				  for(int j=0; j<population.get(i).numberOfInputs(); j++){ // For each part of the solution
					   
					
						   double randNumber = RandomGenerator.Randdouble(0, 1);
						   
						   if(randNumber<this.CrossOverRate[i] || j == j_rand){
							   crossover.setInput(j, mutation.getInput(j)); // Overwrite.
						   }
					   
							   
				   }
				   
				   // Fourth: Selection Operation.
				   // Decide if the trial vector is better than initial population.
				   //Crossover has the trialVector, we check its fitness.
		
					  double trialVector = fitness(crossover);
					  eval++;
					   if(eval > MaxEval)
						   exit = true;
						

					  if(trialVector < fitness[i]){
						//  System.out.println("Selecting");
						  //Archivo.set(utilArchivo%PopulationSize, population.get(i));
						  Archivo.add(population.get(i));
						  utilArchivo++;
						  SCR[utilCR%PopulationSize] = this.CrossOverRate[i];
						  utilCR++;
						  SF[utilF%PopulationSize] = F[i];
						  utilF++;
						  
						  population.set(i, crossover);
						  fitness[i] = trialVector;
						  //utilArchivo = utilArchivo%PopulationSize;
					  }
					   
					  
					  if(fitness[i]<bestFitness){
						  bestFitness = fitness[i];
						  bestFitnessIndex=i;
						  
						 // System.out.println("Iter="+ iter +" Acc= "+ bestFitness); //Useful to show the convergence process.
					  }
				
				  
				  
			   }
			//  System.out.println("Best Fitness Generaci�n "+iter+" = " + bestFitness);
			  // Now we remove solutions from A.
			  
			  if(utilArchivo > this.PopulationSize){
				  utilArchivo = this.PopulationSize;
				  do{
					  Archivo.remove(RandomGenerator.Randint(0, Archivo.size()-1));
				  }while(Archivo.size() > this.PopulationSize);
			  }

			  double meanA= 0;
			  double meanL =0;
			  double numerator=0, denominator =0;
			  
			  for(int i=0; i< utilCR; i++){
				  meanA+= SCR[i];
				  numerator += SF[i] * SF[i];
				  denominator += SF[i];
			  }
			  
			  if(numerator == 0) numerator =1;
			  if(denominator ==0) denominator = 1;
			  
			  meanL = numerator/denominator;
			  meanA = meanA/utilCR;
			  
			  meanCR =(1-c)*meanCR + c * meanA;
			  meanF = (1-c)*meanF + c * meanL;
			  


	   } // End main LOOP
	     
	   
  
	   //System.out.println("Best -> "+ fitness[bestFitnessIndex]);  
	   System.out.println(semilla + "," + function.name() + "," + function.bias() + ","+
				fitness[bestFitnessIndex] + "," + Math.abs(fitness[bestFitnessIndex]-bias) + "," + eval);
  }
  
  
  public void leerConfiguracion (String ficheroScript) {

	    String fichero, linea, token;
	    StringTokenizer lineasFichero, tokens;
	    byte line[];
	    int i, j;

	    fichero = Fichero.leeFichero (ficheroScript);
	    lineasFichero = new StringTokenizer (fichero,"\n\r");


	    /*Getting the seed*/
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    semilla = Long.parseLong(tokens.nextToken().substring(1));
		RandomGenerator.setSeed(semilla);
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.PopulationSize = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Dimension = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.MaxIter = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.p = Double.parseDouble(tokens.nextToken().substring(1));
	
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.c = Double.parseDouble(tokens.nextToken().substring(1));
		
		linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
		int fun =Integer.parseInt(tokens.nextToken().substring(1));
	    this.function = test.testFunctionFactory(fun, Dimension);
		bias = function.bias();
		MaxEval = Dimension*10000;
		eval = 0;
		maxLimit = test.get_max_value(fun);
		minLimit = test.get_min_value(fun);
		if(fun == 7 || fun == 25){
			noBounds = true;
		}


	  }
  
  
  
  /**
   * @param args Arguments of the main function.
   */
  public static void main(String[] args)
  {
	  
	  RandomGenerator.setSeed(868469644); // established the seed.
	  
	  //Default values
	  int Poblacion=100, dimension=50, iteraciones=100000;
	  double p=.05, c=.1;

	  
	  JADEGenerator differential = new JADEGenerator(Poblacion,dimension,iteraciones, p,c);
	  
	  
	  if(args.length == 1){
			differential.leerConfiguracion(args[0]);  
		  }
	  
	  long t0 = System.currentTimeMillis();
	  differential.execute();
	  long t1 = System.currentTimeMillis();
	  
	  System.out.println(t1-t0);
	  
  }

}