
/*
	SADE.java
	Isaac Triguero Velazquez.
	
	Created by Isaac Triguero Velazquez  23-7-2009
	Copyright (c) 2008 __MyCompanyName__. All rights reserved.

*/
package org.sci2s.eamhco;

import java.util.*;
import cec05.benchmark;
import cec05.test_func;




/**
 * @author Isaac Triguero
 * @version 1.0
 */
public class SADEGenerator  {

  /*Own parameters of the algorithm*/
  
  // We need the variable K to use with k-NN rule
  private int k;
 
  private int PopulationSize; 
  private int Dimension;
  private int MaxIter; 
  private double ScalingFactor;
  private double CrossOverRate[];
  private int LearningPeriod;
  private int Strategy;
  private int numberOfStrategies = 4;
  
  private double PI = 3.14159265358;
  private long semilla;
  
  private int MaxEval;
  private int eval;
  private benchmark test;
  private test_func function;
  private double bias;
  private double maxLimit;
  private double minLimit;
  private boolean noBounds = false;
  
  /**
   * Build a new DEGenerator Algorithm
   */
  
  public SADEGenerator(int poblacion, int dimension, int iteraciones, int LP)
  {
      this.PopulationSize = poblacion;
      this.Dimension = dimension;
      this.MaxIter = iteraciones;
      this.LearningPeriod = LP;
	  test = new benchmark();
	  MaxEval = Dimension*10000;
	  eval = 0;
	  function = test.testFunctionFactory(9, dimension);
      
  }

  

  /*
   * Useful functions
   */
  
  public void inic_vector_sin(int vector[], int without){

  	for(int i=0; i<vector.length; i++) 
  		if(i!=without)
  			vector[i] = i; // Lo inicializo de 1 a n-1
  }


  public void desordenar_vector_sin(int vector[]){
  	int tmp, pos;
  	for(int i=0; i<vector.length-1; i++){
  		pos = RandomGenerator.Randint(0, vector.length-1);
  		tmp = vector[i];
  		vector[i] = vector[pos];
  		vector[pos] = tmp;
  	}
  }
  
  
  
  /**
   * I modified the order of the list of strategies,  i need it because i want to do the Same POOL like the paper.
   * Original POOL = DE/Rand/1/bin. | DE/rand-to-best/2/bin | De/Rand/2/bin | DE/current-to-rand/1/arithmetic
   * @param population
   * @param actual
   * @param mejor
   * @return
   */
  public Prototype mutant(ArrayList<Prototype> population, int actual, int mejor){
	  
	  Prototype mutant = new Prototype();
	  Prototype r1,r2,r3,r4,r5, resta, producto, resta2, producto2, result, producto3, resta3;
	  
	//We need three differents solutions of actual
		   
	  int lista[] = new int[population.size()];
      inic_vector_sin(lista,actual);
      desordenar_vector_sin(lista);
		      
	  // System.out.println("Lista = "+lista[0]+","+ lista[1]+","+lista[2]);
	  
	   r1 = population.get(lista[0]);
	   r2 = population.get(lista[1]);
	   r3 = population.get(lista[2]);
	   r4 = population.get(lista[3]);
	   r5 = population.get(lista[4]);
	   
		double SFi = this.ScalingFactor;
		   
			switch(this.Strategy){
		   	   case 1: // ViG = Xr1,G + F(Xr2,G - Xr3,G) De rand 1
			   		 resta = r2.sub(r3);
			   		 producto = resta.mul(SFi);
			   		 mutant = producto.add(r1);
		   	    break;
			   
		   	   case 2:  //DE rand 2
		   		   resta = r2.sub(r3);
		   		   resta2 = r4.sub(r5);
		   		 			   		 
	  		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   		
			   	   result = r1.add(producto);
			   	   mutant = result.add(producto2);
			   break;
			   
			   
		   	   case 3: 		//DE rand to best 2
		   		   resta = r1.sub(r2);
		   		   resta2 = r3.sub(r4);
		   		   resta3 =population.get(mejor).sub(population.get(actual)); 
		   		   
	  		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   	   producto3 = resta3.mul(SFi);
			   	   
			   	   result = population.get(actual).add(producto);
			   	   result = result.add(producto2);
			   	   mutant = result.add(producto3);
			   	   

			   		 			   		 
			   break;
			   
		   	   case 4: //DE current to rand 1
		   		   resta = r1.sub(population.get(actual)); 
		   		   resta2 = r2.sub(r3);
		   		 		   		 
			   	   producto = resta.mul(RandomGenerator.Randdouble(0, 1));
			   	   producto2 = resta2.mul(this.ScalingFactor);
			   		
			   	   result = population.get(actual).add(producto);
			   	   mutant = result.add(producto2);
			   	   
			   break;
			  
			
		   		 
  		       
		   }   
	   

	 // System.out.println("********Mutante**********");
	 // mutant.print();
     mutant.applyThresholds(minLimit, maxLimit);
	   

	  return mutant;
  }
  
  
  public double Skg (int strategy, int successRate[][], int failureRate[][]){
	  double numerator=0, denominator=0;
	  
	  for(int k=0; k<this.LearningPeriod; k++){
		  numerator += successRate[k][strategy];
		  denominator += successRate[k][strategy] + failureRate[k][strategy];
	  }
	  
	  double SKG = numerator/denominator + 0.01; // Add epsilon 0.01
	  
	  return SKG;
  }
  
  /*
   * The probability of use the K strategy is:  pk,G = SkG / SUM(Sk,g).
   */
  
  public double updateProbability(int strategy,int successRate[][],int failureRate[][]){
	  
	  double numerator=0, denominator =0;
	  
	  numerator =Skg(strategy,successRate, failureRate);
	  
	  for(int i =0; i< this.numberOfStrategies;i++){
		  denominator+=Skg(i,successRate, failureRate);
	  }
	  
	  
	  return (numerator/denominator);
  }
  
  /**
   * I use this function to calculate what strategy we must use with the probability strategy we have.
   * @param ProbabilityStrategy
   * @return
   */
  public int selectStrategy(double ProbabilityStrategy[]){
	  
	  double random=RandomGenerator.Randdouble(0, 1);
	  //System.out.println("Random = "+random);
	  double aux =0;
	  boolean end = false;
	  int selected=1;
	  
	  for(int i=0; i< this.numberOfStrategies && !end; i++){
		  aux += ProbabilityStrategy[i];
		  
		 if(random <= aux){
			 selected = i+1; // because we count 1..to 7 strategy.
			 end  =true;
		 }
	  }
	  
	  return selected;
  }
  
  
  /* Code to evaluate rastrigin's function */
  double calc_rastrigin (double x[])
  {
      int i;
      double res;
      res = 0.0;
      for (i=0; i<this.Dimension; i++)
      {
          res += (x[i]*x[i] - 10.0*Math.cos(2.0*this.PI*x[i]) + 10.0);
      }
      return (res-(330));
  }
  
  /*
   * HERE YOU CAN CHANGE THE FUNCTION: function f9
   */
  
  double fitness(Prototype p){
	  
	  return function.f(p.getInputs());
	  
  }
  
  
  /**
   * Generate a reduced prototype set by the SADEGenerator method.
   * @return Reduced set by SADEGenerator's method.
   */
  
  
  public void execute()
  {
	  //System.out.print("\nThe algorithm  SADE is starting...\n Computing...\n");
	  


	  //Algorithm
	  // First, we create the population, with PopulationSize.

	  
	  ArrayList<Prototype> population = new ArrayList<Prototype>();
	  Prototype mutation = new Prototype();
	  Prototype crossover = new Prototype();
	  
 
	  
	  // Variables necesarias para hacer el algoritmo adaptativo.
	  int kStrategies = this.numberOfStrategies;
	
	  double ProbabilityStrategy[] = new double[kStrategies];
	  double CRmk[] = new double[kStrategies];
	  double CRmemory[][] = new double[this.LearningPeriod][];
	  int CRmiter[] = new int[kStrategies];
	  double CRm=0.5;
	  
	  int successRate[][] = new int[this.LearningPeriod][];
	  int failureRate[][] = new int[this.LearningPeriod][];
	  
	  for(int i=0; i<this.LearningPeriod; i++){
		  successRate[i] = new int[kStrategies];
		  failureRate[i] = new int[kStrategies];
		  CRmemory[i] = new double[kStrategies];
		  for(int j=0; j<kStrategies; j++){
			  successRate[i][j] = 1;
			  failureRate[i][j] = 1;
			  CRmemory[i][j] = 0.5;
		  }
	  }
	  
	  /* In SaDE algorithm, the initial probability of use each strategy
	   * is 1/kStrategies.
	   */
	  
	  for(int i=0; i<ProbabilityStrategy.length; i++){
		  ProbabilityStrategy[i] = 1./kStrategies;
		  CRmk[i] = 0.5; // Initial 0.5
		  CRmiter[i] = 0;
	  }
	  
	  //each Strategy has different  CR.	  
	  this.CrossOverRate= new double[this.numberOfStrategies];
	  double F[] = new double[this.PopulationSize];
	  
	  double fitness[] = new double[PopulationSize];

	  
	  
  
	  //Each particle must have   Particle Size %

	  
// First Stage, Initialization.
	  
	  for(int i=0; i< PopulationSize; i++){
		  Prototype cromosoma = new Prototype(this.Dimension,1);
		  
		  for(int j=0; j< this.Dimension; j++){
			  cromosoma.setInput(j, RandomGenerator.Randdouble(minLimit, maxLimit));  //Inicialmente aleatorio.
		  }
		  
		  
		  fitness[i]= fitness(cromosoma);
		  eval++;
		//  System.out.println(fitness[i]);
		  population.add(cromosoma);
	  }
	  if(noBounds){
		  maxLimit = Double.MAX_VALUE;
		  minLimit = Double.MIN_VALUE;
	  }
	  
	  
 	  //Find the best initial solution.

	 	  
	  //We select the best initial  particle
	 double bestFitness=fitness[0];
	 int bestFitnessIndex=0;
	
	 for(int i=1; i< PopulationSize;i++){
		  if(fitness[i]<bestFitness){
			  bestFitness = fitness[i];
			  bestFitnessIndex=i;
		  }
		  
	  }
	 
	 
	   //Step 3:
	   boolean exit = false;
	   for(int iter=1; eval < MaxEval && (Math.abs(bestFitness - bias))> Math.pow(10, -8) && !exit; iter++){ // Main loop
		   
	  		  
			   //Step 3.1
			  if(iter > this.LearningPeriod){  // if G > LP
				  
				  for(int k=0; k<kStrategies; k++){
						  
					  // Update Pk,G ->  PjIter
					  ProbabilityStrategy[k]= updateProbability(k, successRate, failureRate);


					  // Remove the first element of Success and failure memory.
					  successRate[iter%this.LearningPeriod][k]= 0;
					  failureRate[iter%this.LearningPeriod][k] =0;
				  }
				 // System.out.println("********");
				  
			  } 
			  
			  /* Step 3.2.*/
			  // Assign trial vector generation strategy: Lo eligo a posteriori antes de cada llamada a mutaci�n.
			  //System.out.println("Aplicamos las estrategia = "+ this.Strategy);
			  
			  // assign control parameter F . N(0.5,0.3)
			  // if Z sigue una distrubuci�n 0,1, X = sigma*Z + mu sigue la dis n(mu,sigma) 
			  for(int i=0; i< this.PopulationSize; i++){
				  F[i]= RandomGenerator.RandGaussian()*0.3 + 0.5;
			  }
			 // System.out.println("Scaling Factor = "+ this.ScalingFactor); // Correcto
			  
			  
			  /* Assign control parameter CR */
			  if(iter>this.LearningPeriod){
				 
				  for(int k=0; k< this.numberOfStrategies; k++){
					  ArrayList<Double> order = new ArrayList<Double>();
					  //CRmk[k] = 0 ;
					  
					  for(int m=0; m< this.LearningPeriod; m++){
						  //CRmk[k] += CRmemory[m][k];
						  order.add(CRmemory[m][k]);
					  }
					  
					  Collections.sort(order);

					  if (order.size() % 2 == 1)
						  CRmk[k] = order.get((order.size()+1)/2-1);
					  else{
						  double lower = order.get(order.size()/2-1);
						  double upper = order.get(order.size()/2);

						  CRmk[k] = (lower + upper) / 2.0;
					  //CRmk[k] /= this.LearningPeriod;
					  }
				  }
				  
			  }
			  
			  for (int k=0; k< this.numberOfStrategies; k++){
				 this.CrossOverRate[k] =   RandomGenerator.RandGaussian()*0.1 + CRmk[k];
				 
				 while( this.CrossOverRate[k] < 0 || this.CrossOverRate[k]>1){
					 this.CrossOverRate[k] =   RandomGenerator.RandGaussian()*0.1 + CRmk[k];
				 }
			  }
			  
			  //System.out.println("CR k= " + this.CrossOverRate[this.Strategy-1]);
			  /* Step 3.3*/
			  
			  for(int i=0; i<PopulationSize; i++){
				  // Assign trial vector generation strategy
				  this.Strategy = selectStrategy(ProbabilityStrategy); // cada estrategia se elige antes de cada 
				  
				   //Second:  Mutation Operation.
				   // I want to generate a PrototypeSet Mutation for each item of the population.
				   this.ScalingFactor = F[i];
				   
				   mutation = new Prototype();
			   
				   // Pasamos la poblaci�n, y la mejor actual, por si se usa /best/
				   mutation = mutant(population, i,bestFitnessIndex);
	
				   // Third: Crossver Operation.
				   // Now, we decide if the mutation will be the trial vector.
				   
				   crossover = new Prototype(population.get(i));
				   
				   if(this.Strategy !=4){
					   
					   int j_rand = RandomGenerator.Randint(0, Dimension);
					   for(int j=0; j< (population.get(i)).numberOfInputs(); j++){ // For each part of the solution
						   
						   double randNumber = RandomGenerator.Randdouble(0, 1);
							   
						   if(randNumber<CrossOverRate[this.Strategy] || j == j_rand){
							   crossover.setInput(j, mutation.getInput(j)); 
						   }
					   }

				   }else{ // if we use currento-rand, "there is no crossover, It's ready in mutation operator"
					   crossover = mutation; // Overwrite.
				   }
				   
				   //Fourth : Selection Operator.
				   double trialVector = fitness(crossover);
				   eval++;
				   if(eval > MaxEval)
					   exit = true;
					
					  
					  //double trialVector = accuracy(crossover[i],trainingDataSet);
					  //fitness[i] = accuracy(population[i],trainingDataSet);
					  
					  //System.out.println("Trial Vector fitness = "+ trialVector);
					  //System.out.println("fitness de la particula = "+ fitness[i]);
					  
					  if(trialVector < fitness[i]){
						//  System.out.println("Selecting");
						  successRate[iter%this.LearningPeriod][this.Strategy-1]++;
						  CRmemory[CRmiter[this.Strategy-1]][this.Strategy-1] = this.CrossOverRate[this.Strategy-1];
						  CRmiter[this.Strategy-1] = (CRmiter[this.Strategy-1] +1) % this.LearningPeriod;
						  population.set(i, crossover);
						  fitness[i] = trialVector;
					  }else{
						  // Actualizo el FailureRate de esta estrategia.
						  failureRate[iter%this.LearningPeriod][this.Strategy-1]++;
					  }
					   
					  
					  if(fitness[i]<bestFitness){
						  bestFitness = fitness[i];
						  bestFitnessIndex=i;
						  
						 // System.out.println("Iter="+ iter +" Acc= "+ bestFitness); //Useful to show the convergence process.
					  }  
					  
				  
		   } // End population Size


		   
	   }

	    
	   //System.out.println("Best -> "+ fitness[bestFitnessIndex]);  
	   System.out.println(semilla + "," + function.name() + "," + function.bias() + ","+
				fitness[bestFitnessIndex] + "," + Math.abs(fitness[bestFitnessIndex]-bias) + "," + eval);


		
  } // End execute
  
  
  
  public void leerConfiguracion (String ficheroScript) {

	    String fichero, linea, token;
	    StringTokenizer lineasFichero, tokens;
	    byte line[];
	    int i, j;

	    fichero = Fichero.leeFichero (ficheroScript);
	    lineasFichero = new StringTokenizer (fichero,"\n\r");


	    /*Getting the seed*/
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    semilla = Long.parseLong(tokens.nextToken().substring(1));
		RandomGenerator.setSeed(semilla);
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.PopulationSize = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Dimension = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.MaxIter = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.LearningPeriod = Integer.parseInt(tokens.nextToken().substring(1));
		
		linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
		int fun =Integer.parseInt(tokens.nextToken().substring(1));
	    this.function = test.testFunctionFactory(fun, Dimension);
		bias = function.bias();
		MaxEval = Dimension*10000;
		eval = 0;
		maxLimit = test.get_max_value(fun);
		minLimit = test.get_min_value(fun);
		if(fun == 7 || fun == 25){
			noBounds = true;
		}
	    
	    
	  }
  
  
  /**
   * @param args Arguments of the main function.
   */
  public static void main(String[] args)
  {
	  
	  RandomGenerator.setSeed(818469644); // established the seed.
	  
	  //Default values
	  int Poblacion=100, dimension=10, iteraciones=100000, LP = 50; // LP is the learning period
	  
	  SADEGenerator differential = new SADEGenerator(Poblacion,dimension,iteraciones, LP);
	  
	  
	  if(args.length == 1){
			differential.leerConfiguracion(args[0]);  
		  }
	  
	  
	  differential.execute();
	  
	  
  }

}