/*
	SFLSDE.java
	Isaac Triguero Velazquez.
	
	Created by Isaac Triguero Velazquez  23-7-2009
	Copyright (c) 2008 __MyCompanyName__. All rights reserved.

*/

package org.sci2s.eamhco;
import java.util.*;
import cec05.benchmark;
import cec05.test_func;



/**
 * @author Isaac Triguero
 * @version 1.0
 */
public class SFLSDEGenerator{

  /*Own parameters of the algorithm*/
  
	  private int PopulationSize; 
	  private int Dimension;
	  private int MaxIter; 
	  private double ScalingFactor;
	  private double CrossOverRate;
	  private int Strategy;
	  private long semilla;
	  
	  
	  private double PI = 3.14159265358;
	  
	  private double tau[] = new double[4];
	  private double Fl, Fu;
	  
	  private int iterSFGSS;
	  private int iterSFHC;
  
	  private int MaxEval;
	  private int eval;
	  private benchmark test;
	  private test_func function;
	  private double bias;
	  private double maxLimit;
	  private double minLimit;
	  private int lista[];
	  private boolean noBounds = false;
	  
	  
	  /**
	   * Build a new DEGenerator Algorithm
	   */
	  
	  public SFLSDEGenerator(int poblacion, int dimension, int iteraciones, double F, double CR, int strg)
	  {
	      this.PopulationSize = poblacion;
	      this.Dimension = dimension;
	      this.MaxIter = iteraciones;
	      this.ScalingFactor = F;
	      this.CrossOverRate = CR;
	      this.Strategy = strg;
		  
		  test = new benchmark();
		  MaxEval = Dimension*10000;
		  eval = 0;
		  function = test.testFunctionFactory(9, dimension);

	      
	      this.Fl = 0.1;
	      this.Fu = 0.9;
	      this.tau[0] = 0.1;
	      this.tau[1] = 0.1;
	      this.tau[2] = 0.03;
	      this.tau[3] = 0.07;
      
	  }


  

	  /*
	   * Useful functions
	   */
	  
	  public void inic_vector_sin(int vector[], int without){

	  	for(int i=0; i<vector.length; i++) 
	  		if(i!=without)
	  			vector[i] = i; // Lo inicializo de 1 a n-1
	  }


	  public void desordenar_vector_sin(int vector[]){
	  	int tmp, pos;
	  	for(int i=0; i<vector.length-1; i++){
	  		pos = RandomGenerator.Randint(0, vector.length-1);
	  		tmp = vector[i];
	  		vector[i] = vector[pos];
	  		vector[pos] = tmp;
	  	}
	  }
	  

  
  
	  public Prototype mutant(ArrayList<Prototype> population, int actual, int mejor, double SFi){
		  
		  
		  Prototype mutant = new Prototype();
		  Prototype r1,r2,r3,r4,r5, resta, producto, resta2, producto2, result, producto3, resta3;
		  
		//We need five different solutions of actual
			   
		  /*int lista[] = new int[population.size()-1];
	      inic_vector_sin(lista,actual);
	      desordenar_vector_sin(lista);*/
			      
		  // System.out.println("Lista = "+lista[0]+","+ lista[1]+","+lista[2]);
		  
		   r1 = population.get(lista[0]);
		   r2 = population.get(lista[1]);
		   r3 = population.get(lista[2]);
		   r4 = population.get(lista[3]);
		   r5 = population.get(lista[4]);
			
	
		   
				switch(this.Strategy){
			   	   case 1: // ViG = Xr1,G + F(Xr2,G - Xr3,G) De rand 1
				   		 resta = r2.sub(r3);
				   		 producto = resta.mul(SFi);
				   		 mutant = producto.add(r1);
			   	    break;
				   
			   	case 2: // Vig = Xbest,G + F(Xr2,G - Xr3,G)  De best 1
			   		   
			   		 resta = r2.sub(r3);
			   		 producto = resta.mul(SFi);
			   		 mutant = population.get(mejor).add(producto);
			   break;
			   
		   	   case 3: // Vig = ... De rand to best 1
		   		   resta = r1.sub(r2);
		   		    	resta2 = population.get(mejor).sub(population.get(actual));
		   		 			   		 
		   		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   		
			   	   result = population.get(actual).add(producto);
			   	   mutant = result.add(producto2);
			   		 			   		 
			   break;
			   
		   	   case 4: // DE best 2
		   		   resta = r1.sub(r2);
		   		   resta2 = r3.sub(r4);
		   		 			   		 
	   		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   		
			   	   result = population.get(mejor).add(producto);
			   	   mutant = result.add(producto2);
			   break;
			  
		   	   case 5: //DE rand 2
		   		   resta = r2.sub(r3);
		   		   resta2 = r4.sub(r5);
		   		 			   		 
	  		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   		
			   	   result = r1.add(producto);
			   	   mutant = result.add(producto2);
			   	   
			       break;
			       
		   	   case 6: //DE rand to best 2
		   		   resta = r1.sub(r2);
		   		   resta2 = r3.sub(r4);
		   		   resta3 =population.get(mejor).sub(population.get(actual)); 
		   		   
	  		    	producto = resta.mul(SFi);
		   		    	producto2 = resta2.mul(SFi);
			   	   producto3 = resta3.mul(SFi);
			   	   
			   	   result = population.get(actual).add(producto);
			   	   result = result.add(producto2);
			   	   mutant = result.add(producto3);
			       break;
			       
		   	  /*// Para hacer esta estrat�gia, lo que hay que elegir es CrossoverType = Arithmetic
		   	   * case 7: //DE current to rand 1
		   		   resta = r1.restar(population[actual]); 
		   		   resta2 = r2.restar(r3);
		   		 		   		 
			   	   producto = resta.mulEscalar(RandomGenerator.Randdouble(0, 1));
			   	   producto2 = resta2.mulEscalar(this.ScalingFactor);
			   		
			   	   result = population[actual].sumar(producto);
			   	   mutant = result.sumar(producto2);
			   	   
			       break;
			       */
			   }   
		   

		  // System.out.println("********Mutante**********");
		 // mutant.print();
		   
		  mutant.applyThresholds(minLimit, maxLimit);
		
		  return mutant;
	  }
  
  /**
   * Local Search Fitness Function
   * @param Fi
   * @param xt
   * @param xr
   * @param xs
   * @param actual
   */
  public double lsff(double Fi, double CRi, ArrayList<Prototype> population, int actual, int mejor){
	  Prototype resta, producto, mutant;
	  Prototype crossover;
	  double FitnessFi = 0;
	  
	  
	  //Mutation:
	  mutant = new Prototype();
   	  mutant = mutant(population, actual, mejor, Fi);
   	
   	  
   	  //Crossover
   	  
	   crossover = new Prototype(population.get(actual));
	   
	   for(int j=0; j< (population.get(actual)).numberOfInputs(); j++){ // For each part of the solution
		   
		   double randNumber = RandomGenerator.Randdouble(0, 1);
			   
		   if(randNumber<CRi){
			   crossover.setInput(j, mutant.getInput(j)); 
		   }
	   }
	   
	   
	   
	   // Compute fitness

       FitnessFi = fitness(crossover);
	   
   	   return FitnessFi;
  }
  
  
  
  /**
   * SFGSS local Search.
   * @param population
   * @return
   */
  public Prototype SFGSS(ArrayList<Prototype> population, int actual, int mejor, double CRi){
	  double a=0.1, b=1;
	  double fi1=0, fi2=0, fitnessFi1=0, fitnessFi2=0;
	  double phi = (1+ Math.sqrt(5))/5;
	  double scaling;
	  Prototype crossover, resta, producto, mutant;
	  
	  for (int i=0; i<this.iterSFGSS; i++){ // Computation budjet
	  
		  fi1 = b - (b-a)/phi;
		  fi2 = a + (b-a)/phi;
		  
		  fitnessFi1 = lsff(fi1, CRi, population,actual,mejor);
		  fitnessFi2 = lsff(fi2, CRi,population,actual,mejor);
		  
		  if(fitnessFi1> fitnessFi2){
			  b = fi2;
		  }else{
			  a = fi1;  
		  }
	  
	  } // End While
	  
	  
	  if(fitnessFi1> fitnessFi2){
		  scaling = fi1;
	  }else{
		  scaling = fi2;
	  }
	  
	  
	  //Mutation:
	  mutant = new Prototype();
   	  mutant = mutant(population, actual, mejor, scaling);
   	
   	  
   	  //Crossover
   	  
	   crossover = new Prototype(population.get(actual));
	   
	   for(int j=0; j< (population.get(actual)).numberOfInputs(); j++){ // For each part of the solution
		   
		   double randNumber = RandomGenerator.Randdouble(0, 1);
			   
		   if(randNumber<CRi){
			   crossover.setInput(j, mutant.getInput(j)); 
		   }
	   }
	   
   
	  
	return crossover;
  }
  
  /**
   * SFHC local search
   * @param xt
   * @param xr
   * @param xs
   * @param actual
   * @param SFi
   * @return
   */
  
  public  Prototype SFHC(ArrayList<Prototype> population, int actual, int mejor, double SFi, double CRi){
	  double fitnessFi1, fitnessFi2, fitnessFi3, bestFi;
	  Prototype crossover, resta, producto, mutant;
	  double h= 0.5;
	  
	  
	  for (int i=0; i<this.iterSFHC; i++){ // Computation budjet
		  		  
		  fitnessFi1 = lsff(SFi-h, CRi, population,actual,mejor);
		  fitnessFi2 = lsff(SFi, CRi,  population,actual,mejor);
		  fitnessFi3 = lsff(SFi+h, CRi,  population,actual,mejor);
		  
		  if(fitnessFi1 >= fitnessFi2 && fitnessFi1 >= fitnessFi3){
			  bestFi = SFi-h;
		  }else if(fitnessFi2 >= fitnessFi1 && fitnessFi2 >= fitnessFi3){
			  bestFi = SFi;
			  h = h/2; // H is halved.
		  }else{
			  bestFi = SFi;
		  }
		  
		  SFi = bestFi;
	  }
	  
	  
	  //Mutation:
	  mutant = new Prototype();
   	  mutant = mutant(population, actual, mejor, SFi);
   	
   	  
   	  //Crossover
   	  
	   crossover = new Prototype(population.get(actual));
	   
	   for(int j=0; j< (population.get(actual)).numberOfInputs(); j++){ // For each part of the solution
		   
		   double randNumber = RandomGenerator.Randdouble(0, 1);
			   
		   if(randNumber<CRi){
			   crossover.setInput(j, mutant.getInput(j)); 
		   }
	   }
	   
	   
	  
	return crossover;
  
  }
  
  
  
  /* Code to evaluate rastrigin's function */
  double calc_rastrigin (double x[])
  {
      int i;
      double res;
      res = 0.0;
      for (i=0; i<this.Dimension; i++)
      {
          res += (x[i]*x[i] - 10.0*Math.cos(2.0*this.PI*x[i]) + 10.0);
      }
      return (res-(330));
  }
  
  /*
   * HERE YOU CAN CHANGE THE FUNCTION: function f9
   */
  
  double fitness(Prototype p){
	  
	  return function.f(p.getInputs());
	  
  }
  
  /**
   * Execute the DEGenerator method.
   */
  
  
  public void execute()
  {
	  //System.out.print("\nThe algorithm  SFLSDE is starting...\n Computing...\n");
	  
	  	 	    
	  // First, we create the population, with PopulationSize.
	  ArrayList<Prototype> population = new ArrayList<Prototype>();
	  Prototype mutation = new Prototype();
	  Prototype crossover = new Prototype();
	  double ScalingFactor[] = new double[this.PopulationSize];
	  double CrossOverRate[] = new double[this.PopulationSize]; // Inside of the Optimization process.
	  double fitness[] = new double[PopulationSize];

	  
	  // First Stage, Initialization.
	  
	  for(int i=0; i< PopulationSize; i++){
		  Prototype cromosoma = new Prototype(this.Dimension,1);
		  
		  for(int j=0; j< this.Dimension; j++){
			  cromosoma.setInput(j, RandomGenerator.Randdouble(minLimit, maxLimit));  //Inicialmente aleatorio.
		  }
		  
		  
		  fitness[i]= fitness(cromosoma);
		  eval++;
		//  System.out.println(fitness[i]);
		  population.add(cromosoma);
	  }
	  
	  if(noBounds){
		  maxLimit = Double.MAX_VALUE;
		  minLimit = Double.MIN_VALUE;
	  }
	  
	  
 	  //Find the best initial solution.

	 	  
	  //We select the best initial  particle
	 double bestFitness=fitness[0];
	 int bestFitnessIndex=0;
	
	 for(int i=1; i< PopulationSize;i++){
		  if(fitness[i]<bestFitness){
			  bestFitness = fitness[i];
			  bestFitnessIndex=i;
		  }
		  
	  }
	  
      
	   boolean cruceExp [] = new boolean[PopulationSize];
	   
	  lista = new int[population.size()-1];
	   
	   // Initially the Scaling Factor and crossover for each Individual are randomly generated between 0 and 1.
	   
	   for(int i=0; i< this.PopulationSize; i++){
		   ScalingFactor[i] =  RandomGenerator.Randdouble(0, 1);
		   CrossOverRate[i] =  RandomGenerator.Randdouble(0, 1);
	   }
	   
	   
 double randj[] = new double[5];
 boolean exit = false;
	   
	   for(int iter=0; eval < MaxEval && (Math.abs(bestFitness - bias))> Math.pow(10, -8) && !exit; iter++){ // Main loop
		      
		   for(int i=0; i<PopulationSize; i++){

			   //random selecction of index
			  inic_vector_sin(lista,i);
			  desordenar_vector_sin(lista);
			  
			   // Generate randj for j=1 to 5.
			   for(int j=0; j<5; j++){
				   randj[j] = RandomGenerator.Randdouble(0, 1);
			   }
			   
					   
    			   	    
			   
			   if(i==bestFitnessIndex && randj[4] < tau[2]){
				  // System.out.println("SFGSS applied");
				   //SFGSS
				   crossover = SFGSS(population, i, bestFitnessIndex, CrossOverRate[i]);
				   
				   
			   }else if(i==bestFitnessIndex &&  tau[2] <= randj[4] && randj[4] < tau[3]){
				   //SFHC
				   //System.out.println("SFHC applied");
				   crossover = SFHC(population, i, bestFitnessIndex, ScalingFactor[i], CrossOverRate[i]);
				   
			   }else {
				   
				   // Fi update
				   
				   if(randj[1] < tau[0]){
					   ScalingFactor[i] = this.Fl + this.Fu*randj[0];
				   }
				   
				   // CRi update
				   
				   if(randj[3] < tau[1]){
					   CrossOverRate[i] = randj[2];
				   }
				   				   
				   // Mutation Operation.
				   
				   mutation = new Prototype();
			   
				  //Mutation:
					
				   mutation  = mutant(population, i, bestFitnessIndex, ScalingFactor[i]);
				   
				    // Crossver Operation.

				   crossover = new Prototype(population.get(i));
				   
				   for(int j=0; j< (population.get(i)).numberOfInputs(); j++){ // For each part of the solution
					   
					   double randNumber = RandomGenerator.Randdouble(0, 1);
						   
					   if(randNumber<CrossOverRate[i]){
						   crossover.setInput(j, mutation.getInput(j)); 
					   }
				   }
				   
				   //Fourth : Selection Operator.
				   double trialVector = fitness(crossover);
				   eval++;
				   if(eval > MaxEval)
					   exit = true;
					
					  
					  //double trialVector = accuracy(crossover[i],trainingDataSet);
					  //fitness[i] = accuracy(population[i],trainingDataSet);
					  
					  //System.out.println("Trial Vector fitness = "+ trialVector);
					  //System.out.println("fitness de la particula = "+ fitness[i]);
					  
					  if(trialVector < fitness[i]){
						//  System.out.println("Selecting");
						  population.set(i, crossover);
						  fitness[i] = trialVector;
					  }
					   
					  
					  if(fitness[i]<bestFitness){
						  bestFitness = fitness[i];
						  bestFitnessIndex=i;
						  
						 // System.out.println("Iter="+ iter +" Acc= "+ bestFitness); //Useful to show the convergence process.
					  }  
					   
				   
				   
			   }
			   
   
			   
				
			  
			  
		   }

		   //System.out.println("Acc= "+ bestFitness);
	   }//END main loop.
	   
	   


	   //System.out.println("Best -> "+ fitness[bestFitnessIndex]); 
	   System.out.println(semilla + "," + function.name() + "," + function.bias() + ","+
				fitness[bestFitnessIndex] + "," + Math.abs(fitness[bestFitnessIndex]-bias) + "," + eval); 

  
} // END execute function.
  
  
  
  public void leerConfiguracion (String ficheroScript) {

	    String fichero, linea, token;
	    StringTokenizer lineasFichero, tokens;
	    byte line[];
	    int i, j;

	    fichero = Fichero.leeFichero (ficheroScript);
	    lineasFichero = new StringTokenizer (fichero,"\n\r");


	    /*Getting the seed*/
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    semilla = Long.parseLong(tokens.nextToken().substring(1));
		RandomGenerator.setSeed(semilla);
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.PopulationSize = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Dimension = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
  
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.MaxIter = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.iterSFGSS = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.iterSFHC = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Fl =  Double.parseDouble(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Fu =  Double.parseDouble(tokens.nextToken().substring(1));
	    
	    tau = new double[4];
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.tau[0] =  Double.parseDouble(tokens.nextToken().substring(1));
	   
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.tau[1] =  Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.tau[2] =  Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.tau[3] =  Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Strategy = Integer.parseInt(tokens.nextToken().substring(1));
		
		linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
		int fun =Integer.parseInt(tokens.nextToken().substring(1));
	    this.function = test.testFunctionFactory(fun, Dimension);
		bias = function.bias();
		MaxEval = Dimension*10000;
		eval = 0;
		maxLimit = test.get_max_value(fun);
		minLimit = test.get_min_value(fun);
		if(fun == 7 || fun == 25){
			noBounds = true;
		}
	    
	    
	  }
  
  
  /**
   * @param args Arguments of the main function.
   */
  public static void main(String[] args)
  {
	  
	  RandomGenerator.setSeed(818469644); // established the seed.
	  
	  //Default values
	  int Poblacion=100, dimension=10, iteraciones=100000, estrategia =1;
	  double F=.5, CR=.5;
	  
	  SFLSDEGenerator differential = new SFLSDEGenerator(Poblacion,dimension,iteraciones, F,CR,estrategia);
	  
	  if(args.length == 1){
			differential.leerConfiguracion(args[0]);  
	  }
	  
	  
	  differential.execute();
	  
	  
  }

}